<template>
  <div class="options" data-testid="option-list">
    <div
      v-for="(option, index) in optionsList"
      :ref="'option' + index"
      :key="option.value"
      :data-testid="option.value"
      :aria-selected="option.selected"
      :class="optionClasses(option)"
      role="option"
      tabindex="0"
      @keypress.space.prevent="toggleOption(option)"
      @keydown.down.prevent.stop="moveDown"
      @keydown.up.prevent.stop="moveUp"
      @click="toggleOption(option)"
      @focus="onOptionFocus(index)"
    >
      <template v-if="singleMode">
        <sa-icon v-if="option.selected" icon="check" aria-hidden="true" />
        {{ option.label }}
      </template>
      <div v-else class="checkbox">
        <div class="text">
          <sa-icon v-if="option.selected" icon="check" aria-hidden="true" />
          {{ option.label }}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'SaSelect',
  props: {
    options: {
      type: Array,
      default: () => []
    },
    singleMode: {
      type: Boolean,
      default: true
    },
    selection: {
      type: Array,
      default: () => []
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  data: () => ({
    lastFocusIndex: -1
  }),
  computed: {
    optionsList() {
      return this.options.map((option) => {
        if (typeof option === 'object') {
          option = { ...option }
        } else {
          option = {
            value: option,
            label: option
          }
        }
        option.selected = this.selection.includes(option.value)
        return option
      })
    }
  },
  methods: {
    optionClasses(option) {
      return [
        'option',
        'regular',
        { checked: option.selected, disabled: this.disabled }
      ]
    },
    toggleOption(option) {
      if (this.disabled) return
      this.$emit('toggle', option.value)
    },
    moveDown() {
      if (this.lastFocusIndex < this.optionsList.length - 1) {
        this.focusOption(this.lastFocusIndex + 1)
      }
    },
    moveUp() {
      if (this.lastFocusIndex === -1) {
        this.focusOption(this.optionsList.length - 1)
      } else if (this.lastFocusIndex > 0) {
        this.focusOption(this.lastFocusIndex - 1)
      }
    },
    focusFirst() {
      this.focusOption(0)
    },
    focusLast() {
      this.focusOption(this.optionsList.length - 1)
    },
    focusOption(index) {
      if (this.disabled) return
      // note: was previously using a single 'options' ref in the v-for, but the order
      // of the items in the $refs is not guaranteed to reflect the order of the DOM
      // elements when they are added/removed, so need to use unique refs instead
      this.$refs['option' + index][0].focus()
    },
    onOptionFocus(optionIndex) {
      this.lastFocusIndex = optionIndex
    }
  }
}
</script>

<style lang="scss" scoped>
.options {
  padding: 0;
  .icon {
    margin-right: spacing(0);
  }
}
</style>
